# Twin Config

This section explains how the **desired** properties in the module twin is used in the **ConfigModule**, and how a asset hierarchy deployment influences it.

* **ConfigSasUri**: SasUri for the current configuration file. Loading of the file will be triggered, if the current config version does not match the desired.
* **ConfigVersion**: The target version of the configuration that should be active on the device. Must correspond with the version of the config file, referenced in the ConfigSasUri property. Otherwise an error is reported.
* **ConfigMode**: Desired config mode. Multiple sets of tag configurations can be set into the tag configuration file, where each set is called a *Config Mode*. The actual active config mode can be set in this property, if the **ConfigModeControl** property is set to *Twin*.
* **ConfigModeControl**: Determines how the current config mode is set on the device. Possible options are Twin and Module. Options are:
  * **Twin**: The actual config mode is controlled by the *ConfigMode* twin property, and can only be set using the desired twin.
  * **Module**: The actual config mode is controlled by calling the *SetConfigMode* direct command, which can be done from other modules or from the cloud.

The example below shows a configuration:

```
  "configSettings": {
    "configMode": "default",
    "configModeControl": "twin",
    "configSasUri": "https://somestorage.blob.core.windows.net/config/mydevice/config.json?sv=2025-11-05&spr=https&st=2025-10-21T08%3A55%3A07Z&se=2026-10-21T09%3A05%3A07Z&sr=b&sp=r&sig=somekey",
    "configVersion": "32314ed2-8f38-48f9-8ad4-5524123f782e"
  }
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.tricloudnexus.io/edge/nexus-modules/platform-modules/configmodule/twin-config.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
